---
title: EventListener
slug: Web/API/EventListener
tags:
  - API
  - DOM
  - DOM Events
  - Interface
  - events
---
<div>{{APIRef("DOM Events")}}</div>

<p>The <strong><code>EventListener</code></strong> interface represents an object that can handle an event dispatched by an {{domxref("EventTarget")}} object.</p>

<div class="note">
<p><strong>Note:</strong> Due to the need for compatibility with legacy content, <code>EventListener</code> accepts both a function and an object with a <code>handleEvent()</code> property function. This is shown in the <a href="#Example">example</a> below.</p>
</div>

<h2 id="Properties">Properties</h2>

<p><em>This interface neither implements, nor inherits, any properties.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>This interface doesn't inherit any methods.</em></p>

<dl>
 <dt>{{domxref("EventListener.handleEvent()")}}</dt>
 <dd>A function that is called whenever an event of the specified type occurs.</dd>
</dl>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;button id="btn"&gt;Click here!&lt;/button&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">const buttonElement = document.getElementById('btn');

// Add a handler for the 'click' event by providing a callback function.
// Whenever the element is clicked, a pop-up with "Element clicked!" will
// appear.
buttonElement.addEventListener('click', function (event) {
  alert('Element clicked through function!');
});

// For compatibility, a non-function object with a `handleEvent` property is
// treated just the same as a function itself.
buttonElement.addEventListener('click', {
  handleEvent: function (event) {
    alert('Element clicked through handleEvent property!');
  }
});
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example')}}</p>

<h3 id="See_Also">See Also:</h3>

<ul>
 <li><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#callbackdef-eventlistener', 'EventListener')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Events', '#Events-EventListener', 'EventListener')}}</td>
   <td>{{Spec2('DOM2 Events')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.EventListener")}}</p>
